#include "rom.h"

unsigned char *load_rom(char *filename)
{
     unsigned char *rom_ptr;
     long rom_size;
     FILE *rom;
     
     rom = fopen(filename, "rb");
     
     if(!rom)
     {
      printf("Failed to open %s.", filename);
      return 0;
     }

     fseek(rom, 0, SEEK_END);
     rom_size = ftell(rom);
     rewind(rom);
     
     rom_ptr = (unsigned char*)malloc(rom_size);
     
     if(!rom_ptr)
     {
      printf("Failed to allocate memory.");
      return 0;
     }
     
     fread(rom_ptr, 1, rom_size, rom);
     
     fclose(rom);
     
     return rom_ptr;
}

void write_rom(unsigned char *rom_buffer, char *oldfile, char *newfile)
{
     int i;
     long rom_size;
     FILE *rom;
     
     printf("\nOriginal Rom: %s\n", oldfile);
     
     rom = fopen(oldfile, "rb");
     
     if(!rom)
     {
      printf("Failed to open %s.", oldfile);
      return;
     }

     fseek(rom, 0, SEEK_END);
     rom_size = ftell(rom);
     fclose(rom);

     printf("New Rom: %s\n", newfile);

     freopen(newfile, "wb", rom); 
        
     fwrite(rom_buffer, 1, rom_size, rom);
     
     fclose(rom);
}
