#include <stdio.h>
#include <stdlib.h>
#include "rom.h"

typedef unsigned char byte;
typedef short int word;

int main()
{
    byte *rom, *decomp, ctrl_code = 0, bits = 8, test = 0;
    int c, d, length, start, win_len = 0, win_ptr = 0, temp = 0, i;
    FILE *out;

    out = fopen("decomp.bin", "wb");
    if(!out)
    {
     printf("Failed to open decomp.bin");
     return 1;
    }
    
//    rom = load_rom("vgundam.smc");
//    start = 0x140B41; //Start of compressed title data.

	rom = load_rom("compressed.bin");
	start = 0;

	c = start; //compressed block index
	d = 0; //decompressed block index
    
    length = ((rom[c + 1] << 8) | (rom[c]));
    c += 2;

    decomp = (byte *)malloc(length + 1); //allocate the exact amount of memory needed 
    if(!decomp)
    {
     printf("Failed to allocate memory for buffer.\n");
     return 1;
    }

    while(d < length)
    {
     
     if(bits >= 8)
     {
      ctrl_code = rom[c++];
      bits = 0;
     } //if(bits)
          
     test = (ctrl_code >> bits) & 1;
     bits++;
     
     if(test == 1) // uncompressed data
     {
      decomp[d++] = rom[c++];
     }
     else
     {
      //length of the data in the buffer to copy
      win_len = rom[c];
      win_len = (win_len & 0xf) + 2;
      
      //how far to reach in the buffer for the data
      win_ptr = ((rom[c + 1] << 8) | (rom[c]));
      c += 2;
      win_ptr >>= 4;
      
      temp = d;
      temp -= win_ptr;
      
      if(temp < 0) //Negatives are special cases
      {       
       win_ptr = ((temp & 0xff) ^ (0xff)); //8-bits and XOR key
      
       while((win_ptr >= 0) && (win_len >= 0))
       {
        decomp[d++] = 0;

		win_ptr--;
        win_len--;
       }
             
      } //if(temp < 0)
      else
      {
       win_len &= 0xff;
	   win_ptr = temp;
      
       for(i = win_len; i >= 0; i--)
       {
        decomp[d++] = decomp[win_ptr++];
       } //for(i = win_len...)
      } //else
     } //else(compressed)
    } //while(d < length)
    
    for(i = 0; i < length; i++)
    {
     fputc(decomp[i], out);
    }
    
	printf("Compressed data: $%X\tUncompressed: $%X\n", (c - start), length);

    fclose(out);
    free(rom);
    free(decomp);

	system("pause");
    return 0;
}
